package demo.linksprite.mybluetoothwatch.tools;

import android.text.TextUtils;

/**
 * Created by Administrator on 2015/7/29.
 */
public class StrBinaryTurn {

    public static byte[] getstringtobytearr(char[] a) {
        byte[] b = new byte[a.length / 2];
        int i = 0;
        for (int j = 0; j < a.length - 1; j++) {
            char c = a[j];
            char d = a[j + 1];
            b[i] = (byte) ((getchartobyte(c) << 4) | (getchartobyte(d)));
            i++;
            j = j + 1;
        }


        return b;
    }

    public static byte getchartobyte(final char a) {
        byte b = 0;
        int i = 0;
        if (a >= '0' && a <= '9') {
            i = a - '0';
        } else {
            i = a - 'a' + 10;
        }
        b |= (byte) ((((byte) i >> 4) & (0xf)) | ((byte) i & 0xf));

        return b;
    }

    public static String getStringfrombytearr(byte[] a) {
        StringBuffer s = new StringBuffer();
        for (byte b : a) {
            s.append(getStringfrombyte(b));
        }
        return s.toString();
    }


    public static char[] getStringfrombyte(byte a) {
        char[] b = new char[2];
        b[0] = (char) (((char) a >> 4) & 0xf);
        b[1] = (char) ((char) a & 0xf);

        if ((b[0] >= 0) && (b[0] <= 9)) {
            b[0] = (char) (b[0] + '0');
        } else {
            b[0] = (char) (b[0] + 'a' - 10);
        }

        if ((b[1] >= 0) && (b[1] <= 9)) {
            b[1] = (char) (b[1] + '0');
        } else {
            b[1] = (char) (b[1] + 'a' - 10);
        }

        return b;

    }

    public static String getBinaryStrFromByteArr(byte[] bArr) {
        String result = "";
        for (byte b : bArr) {
            result += "\n" + getBinaryStrFromByte(b);
        }
        return result;
    }

    public static String getBinaryStrFromByte(byte b) {
        String result = "";
        byte a = b;
        ;
        for (int i = 0; i < 8; i++) {
            byte c = a;
            a = (byte) (a >> 1);//每移一位如同将10进制数除以2并去掉余数。
            a = (byte) (a << 1);
            if (a == c) {
                result = "0" + result;
            } else {
                result = "1" + result;
            }
            a = (byte) (a >> 1);
        }
        return result;
    }

    /**
     * 将int数值转换为占四个字节的byte数组，本方法适用于(高位在前，低位在后)的顺序。  和bytesToInt2（）配套使用
     */
    public static byte[] intToBytes2(short value) {
        byte[] src = new byte[2];
        src[0] = (byte) ((value >> 8) & 0xFF);
        src[1] = (byte) (value & 0xFF);
        return src;
    }

    public static String toHexString1(byte[] b) {
        StringBuffer buffer = new StringBuffer();
        for (int i = 0; i < b.length; ++i) {
            buffer.append(toHexString1(b[i]));
        }
        return buffer.toString();
    }

    public static String toHexString1(byte b) {
        String s = Integer.toHexString(b & 0xFF);
        if (s.length() == 1) {
            return "0" + s;
        } else {
            return s;
        }
    }

    public static byte hexToByte(char[] chs) {
        if (chs.length > 2)
            return 0;
        int[] b = new int[2];
        for (int i = 0; i < chs.length; i++) {
            if (chs[i] >= '0' && chs[i] <= '9') {
                b[i] = (chs[i] - '0');
            } else if (chs[i] >= 'A' && chs[i] <= 'F') {
                b[i] = (chs[i] - 'A' + 10);
            } else if (chs[i] >= 'a' && chs[i] <= 'f') {
                b[i] = (chs[i] - 'a' + 10);
            }
        }
        b[0] = (b[0] & 0x0f) << 4;
        b[1] = (b[1] & 0x0f);
        return (byte) (b[0] | b[1]);
    }

    public static byte[] hex2Bytes1(String src) {
        byte[] res;
        if (!TextUtils.isEmpty(src)) {
            if (src.length() % 2 != 0) {
                src = src + "0";
            }
            res = new byte[src.length() / 2];
            char[] chs = src.toCharArray();
            int[] b = new int[2];

            for (int i = 0, c = 0; i < chs.length; i += 2, c++) {
                for (int j = 0; j < 2; j++) {
                    if (chs[i + j] >= '0' && chs[i + j] <= '9') {
                        b[j] = (chs[i + j] - '0');
                    } else if (chs[i + j] >= 'A' && chs[i + j] <= 'F') {
                        b[j] = (chs[i + j] - 'A' + 10);
                    } else if (chs[i + j] >= 'a' && chs[i + j] <= 'f') {
                        b[j] = (chs[i + j] - 'a' + 10);
                    }
                }

                b[0] = (b[0] & 0x0f) << 4;
                b[1] = (b[1] & 0x0f);
                res[c] = (byte) (b[0] | b[1]);
            }
        }else {
            res = new byte[1];
        }
        return res;
    }

    public static short bytesToInt(byte high, byte low) {

        int addr = 0;

        addr |= (high << 8) & 0xff00;
        addr |= low & 0xff;
        return (short) addr;

    }

    public static byte[] intToBytes3(int value) {
        byte[] src = new byte[4];
        src[0] = (byte) ((value >> 24) & 0xFF);
        src[1] = (byte) ((value >> 16) & 0xFF);
        src[2] = (byte) ((value >> 8) & 0xFF);
        src[3] = (byte) (value & 0xFF);
        return src;
    }


    public static long bytes2long(byte[] b) {
        long temp = 0;
        long res = 0;
        for (int i = 0; i < 8; i++) {
            res <<= 8;
            temp = b[i] & 0xff;
            res |= temp;
        }
        return res;
    }


    public static byte[] long2bytes(long num) {
        byte[] b = new byte[8];
        for (int i = 0; i < 8; i++) {
            b[i] = (byte) (num >>> (56 - (i * 8)));
        }
        return b;
    }

    public static int bytes2int(byte[] bytes) {
        int num = bytes[3] & 0xFF;
        num |= ((bytes[2] << 8) & 0xFF00);
        num |= ((bytes[1] << 16) & 0xFF0000);
        num |= ((bytes[0] << 24) & 0xFF000000);
        return num;
    }

    public static int byte2uint(byte[] bytes) {
        int num = bytes[1] & 0xFF;
        num |= ((bytes[0] << 8) & 0xFF00);
        return num;
    }

    public static byte[] StringTo32bytearr(String s) {
        byte[] data = new byte[32];
        byte[] sn = hex2Bytes1(s);
        System.arraycopy(sn, 0, data, 0, sn.length);
        return data;
    }

    public static String bytetoHexString(byte b) {
        String s = Integer.toHexString(b & 0xFF);
        if (s.length() == 1) {
            return "0" + s;
        } else {
            return s;
        }
    }

    public static String bytestoHexString(byte[] b) {
        StringBuffer buffer = new StringBuffer();
        for (int i = b.length -1; i >= 0; i--) {
            buffer.append(bytetoHexString(b[i]));
        }
        return buffer.toString();
    }



}
