package demo.linksprite.mybluetoothwatch.tools;

import android.content.Context;
import android.content.SharedPreferences;

/**
 * Created by Administrator on 2015/10/26.
 */
public class SpUtils {

    /**
     * 获取相应的String值
     */

    public static String getString(Context context, String name) {
        SharedPreferences sp = context.getSharedPreferences("config", Context.MODE_PRIVATE);
        String mString = sp.getString(name, null);
        return mString;
    }

    /**
     * 获取相应的int值
     */

    public static int getInt(Context context, String name) {

        SharedPreferences sp = context.getSharedPreferences("config", Context.MODE_PRIVATE);
        int mString = sp.getInt(name, 0);
        return mString;
    }


    /**
     * 获取相应的boolean
     * 值
     */

    public static boolean getBoolean(Context context, String name) {

        SharedPreferences sp = context.getSharedPreferences("config", Context.MODE_PRIVATE);
        Boolean mString = sp.getBoolean(name, false);
        return mString;
    }

    /**
     * 设置相对应的值
     */
    public static void setData(Context context, String name, Object value) {

        SharedPreferences sp = context.getSharedPreferences("config", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        if (value instanceof String) {
            editor.putString(name, (String) value);
        } else if (value instanceof Boolean) {
            editor.putBoolean(name, (Boolean) value);
        } else if (value instanceof Integer) {
            editor.putInt(name, (Integer) value);
        }
        editor.commit();//提交


    }

}
